# Order-Management Backend

This is the backend for the order-management project.

## Installation

Clone this project and CD into the directory and open it up with your favorite editor or IDE of choice.

You are also going to want to install Apache Kafka and get the server running on your local machine before running the backend application.

To install the Apache Kafka , go to this [link](https://www.apache.org/dyn/closer.cgi?path=/kafka/2.8.0/kafka_2.13-2.8.0.tgz) and download the tar.

You then want to unzip the tar file and put it in whatever directory is easiest for you to access.

### Installation Via Homebrew
To install Kafka on your local machine via homebrew, run the following command:
```
brew install kafka
```

## Usage

You want to now open up two separate terminals for running the zookeeper and the kafka server. Once you have two terminals opened up CD into the apache kafka directory in both terminals and run these commands in order:

```
bin/zookeeper-server-start.sh config/zookeeper.properties
```

Now in the other terminal you want to run this command

```
bin/kafka-server-start.sh config/server.properties
```
### Usage Via Homebrew Installation

Once Kafka is installed, run the following command to start Kafka Zookeeper:
```
zookeeper-server-start /usr/local/etc/kafka/zookeeper.properties
```

Next, we need to start the Kafka server, use the following command to do so:
```
kafka-server-start /usr/local/etc/kafka/server.properties
```



Once you have both of these commands running you can now go into your IDE of choice or editor, and run the backend java application. Once the application is running you want to send a POST request - either via curl with a query param of "message=somethinghere" or using a service like postman and have a query params in there. The route you are going to want to hit is http://localhost:8080/kafka/publish.

Example request: 
```
http://localhost:8080/kafka/publish?message=somethinghere
```
Once you hit the route mentioned above with the query param, go back to your IDE and you should see producer sending a message and consumer consuming that message.

Example Console Response:
```
2021-05-05 17:13:29.932  INFO 82715 --- [ntainer#0-0-C-1] c.afp.ordermanagement.service.Consumer   : #### -> Consumed message -> somethinghere
```

## Testing Kafka Producer and Consumer
Make sure kafka server and zookeeper are running

To create a kafka topic:
```
kafka-topics.sh --describe --topic <insert-topic-here> --bootstrap-server localhost:9092
```
if the above command doesn't work, try:
```
/usr/local/Cellar/kafka/2.8.0/bin/kafka-topics  --describe --topic orders --bootstrap-server localhost:9092
```

To start kafka console for producer:
```
kafka-console-producer.sh --topic orders --bootstrap-server localhost:9092
```
-OR-
```
/usr/local/Cellar/kafka/2.8.0/bin/kafka-console-producer --topic orders --bootstrap-server localhost:9092
```

To start kafka console for consumer:
```
kafka-console-consumer.sh --topic orders --from-beginning --bootstrap-server localhost:9092
```
-OR-
```
/usr/local/Cellar/kafka/2.8.0/bin/kafka-console-consumer --topic orders --from-beginning --bootstrap-server localhost:9092 
```

(--from-beginning flag will show all messages that were received for this particular topic)

if you're still getting errors finding the pathway for kafka, try running:
```
ls -alrth /usr/local/Cellar/kafka/  
```  
then find your way to the bin directory where you'll find all the kafka commands