package com.afp.ordermanagement.reactivekafkaservice;

import com.afp.ordermanagement.model.Order;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.kafka.sender.KafkaSender;
import reactor.kafka.sender.SenderRecord;
import reactor.kafka.sender.SenderResult;


@Service
@Slf4j
public class Sender {



    @Autowired
    private KafkaSender<String, Order> kafkaEventProducer;


    private static final String ORDER_TOPIC = "orders";


    public void sendOrderToWarehouse(Order orderObject) {
        log.info(String.format("##### -> Sender sending message: %s ", orderObject));
        ProducerRecord<String, Order> record = new ProducerRecord<>(ORDER_TOPIC, orderObject);
        Flux<SenderResult<Order>> working = kafkaEventProducer.send(Mono.just(SenderRecord.create(record, orderObject)))
                .doOnError(throwable -> System.out.println(throwable))
                .doOnNext(uuidSenderResult -> {
                    if (null != uuidSenderResult.exception()) {
                        System.out.println("working");
                    }
                });
        working.doOnError(throwable -> log.error("some error")).subscribe();
    }


}
