package com.afp.ordermanagement.seeder;

import com.afp.ordermanagement.model.Manager;
import com.afp.ordermanagement.repository.ManagerRepository;
import com.github.javafaker.Faker;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import java.util.stream.IntStream;

@Component
public class ManagerSeeder {
    @Autowired
    ManagerRepository managerRepository;

    static private final Faker FAKER = new Faker();

    static private final int SEED_COUNT = 1;

    @EventListener
    public void seedManager(ContextRefreshedEvent event) {
        managerRepository
                .deleteAll()
                .subscribe();
        IntStream.range(0, SEED_COUNT).forEach(n -> {
            managerRepository
                    .insert(generateManager())
                    .subscribe();
        });
    }

    private Manager generateManager(){
        Manager manager = new Manager();
        manager.setFirstName(FAKER.name().firstName());
        manager.setLastName(FAKER.name().lastName());
        manager.setEmail(FAKER.internet().emailAddress());
        manager.setGoogleId(FAKER.number().digits(21));
        manager.setImageUrl(FAKER.internet().url());
        return manager;
    }
}
