package com.afp.ordermanagement.UNIT_TESTS.model;

import com.afp.ordermanagement.UNIT_TESTS.helper.ValidatableEntity;
import com.afp.ordermanagement.model.Manager;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

public class ManagerTests extends ValidatableEntity<Manager> {
    @ParameterizedTest
    @CsvSource(value = {"null:false", "\"\":false", "Jerry:true"}, delimiter = ':')
    public void shouldValidateNameFields(String input, boolean expected) {
        assertFieldValidation("firstName", input, expected);
        assertFieldValidation("lastName", input, expected);
    }

    @ParameterizedTest
    @CsvSource(value = {"null:false", "\"\":false", "poop:false", "jerry@hotmail.com:true"},  delimiter = ':')
    public void shouldValidateEmailField(String input, boolean expected) {
        assertFieldValidation("email", input, expected);

    }

    @ParameterizedTest
    @CsvSource(value = {"null:false", "\"\":false"},  delimiter = ':')
    public void shouldValidateGoogleIdField(String input, boolean expected) {
        assertFieldValidation("googleId", input, expected);
    }

    @ParameterizedTest
    @CsvSource(value = {"\"\",false", "https://picsum.photos/200,true", "htps: picsum.photos/200,false"})
    public void shouldValidateImageUrl(String input, boolean expected) {
        assertFieldValidation("imageUrl", input, expected);
    }
}
